Option Strict Off
Option Explicit On
Imports System
Imports System.IO
Imports VB = Microsoft.VisualBasic
Friend Class Form1
	Inherits System.Windows.Forms.Form
    '********************************************************************************
    '   Visual Basic.NET VB_Demo Program                                   05-02-2007
    '   Copyright 2009 ICS Electronics div Systems West, Inc.
	'
	'   Example Visual Basic Program controls the GPIB-32.dll with NI type calls
    '   Program is linked to ICS GPIB-32.VB and ICSVB.VB files
	'
    '*********************************************************************************
    '   Change History
    '   06-02-2006  Added Auto Query check box
    '   03-06-2007  Fixed Findlstn and Set to handle secondary addresses correctly.
    '   03-15-2007  Added ibln call to cmdSet
    '   05-02-2007  Added Trigger function and Ctlr GPIB addr query
    '   09-24-2009  Added File create and write data functions
    '   09-25-2009  Added File loop functions
    '*********************************************************************************

	Dim SPACE80S As String
    Public Bd As Short          'GPIB Controller ID
    Public NL As String         'CR LF string
    Public Ctlraddr As Short    'GPIB Controller address
    Public Device As Short      'device ID
    Public Er As Short          'error counter
    Public vtmo As Short        'current Timeout Setting
    Dim resplist(64) As Short
    Dim addrlist(32) As Short
    Public founddev As Short    'address of the first found device
    Dim Devlist(32) As Short    'list of found devices passed to All  Spoll
    Public FoundFlg As Short    'flag indicates a device was found
    Public FoundNum As Short    'number of found devices
	Const winPictureBox As Integer = 2016002
    Const winCommandButton As Integer = 2007557
    Public FILE_NAME As String
    Public sw As System.IO.StreamWriter
    Public RecordFlg As Short
    Dim RecordCnt As Integer
    Public Instring As String
    Dim Revdate As String = "09-26-2009"
    Public FileOpenFlg As Integer

	Private Sub cmdCLS_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCLS.Click
		Dim eotmode As Short
        Dim Outstring As String         'Outputs *CLS string to specified device
        Outstring = "*CLS"              'clears ESR and status registers
		txtResults.Text = ""
        combCmd.Text = ""
        eotmode = GPIB32Funcs.NLend
        Call GPIB32Funcs.Send(Bd, addr, Outstring, eotmode)
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then 'error testing can be removed to shorten program
            Call gpiberr("Send error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            txtResults.Text = "*CLS sent to device" & Str(Device)
        End If
    End Sub

    Private Sub cmdDevClr_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdDevClr.Click 'sends Device Clear to specified device
        combCmd.Text = ""
        Call GPIB32Funcs.DevClear(Bd, addr)     'selected device clear
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("DevCLr Error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            'UPGRADE_WARNING: Couldn't resolve default property of object Device. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
            txtResults.Text = "Selected Device Clear sent to device" & Str(Device)
        End If
    End Sub

    Private Sub cmdExit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdExit.Click
        If FileOpenFlg = 1 Then sw.Close()
        End
    End Sub

    Private Sub cmdFindLstn_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdFindLstn.Click
        Dim flist As String
        Dim ppss As Short
        Dim pad As Short
        Dim sad As Short
        Dim I As Short
        Dim J As Short
        Dim foundaddr As Short
        Dim limit As Short
        txtError.Visible = False
        combCmd.Text = ""
        flist = ""
        limit = 32
        foundaddr = 0
        txtResults.Text = "FindLstn: Wait while looking for devices"
        txtResults.Refresh()
        J = 0
        For I = 0 To 30                     'create Device Addrlist
            If Ctlraddr <> I Then
                addrlist(J) = (I)
                J = J + 1
            End If
        Next I
        addrlist(30) = GPIB32Funcs.NOADDR   'terminate Addrlist

        Call GPIB32Funcs.FindLstn(Bd, addrlist, Devlist, limit)
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then 'added EBUS and ETAB tests 8-20-04
            If (GPIB32Funcs.iberr And GPIB32Funcs.EBUS = GPIB32Funcs.EBUS) Or (GPIB32Funcs.iberr And GPIB32Funcs.ETAB = GPIB32Funcs.ETAB) Then GoTo FLelse
            Call gpiberr("FindLstn error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
FLelse:     flist = ""
            For I = 0 To (GPIB32Funcs.ibcnt - 1)
                If Devlist(I) > 24576 Then      'secondary addresses conversion to ppss format
                    sad = Int((Devlist(I)) / 256)
                    pad = Devlist(I) - ((sad) * 256)
                    ppss = (pad * 100) + (sad - 96)
                    flist = flist & Str(ppss) & " "
                    If I = 0 Then
                        founddev = ppss
                        foundaddr = Devlist(I)
                        FoundFlg = 1
                    End If
                Else                            'primary addresses
                    flist = flist & Str(Devlist(I)) & " "
                    If I = 0 Then
                        founddev = Devlist(I)
                        foundaddr = Devlist(I)
                        FoundFlg = 1
                    End If
                End If
                FoundNum = (GPIB32Funcs.ibcnt)
            Next I
            Select Case GPIB32Funcs.ibcnt
                Case Is > 63
                    Beep()
                    txtError.Text = "Found " & Str(FoundNum) & " devices, check system and retry"
                    txtError.Visible = True
                    txtResults.Text = "FindLstn: Found" & Str(GPIB32Funcs.ibcnt) & " devices at addresses = " & flist
                    txtResults.Text = txtResults.Text + NL + "CAUTION - Not all found devices listed - Check system and retry."
                Case Is > 1
                    txtResults.Text = "FindLstn: Found" & Str(GPIB32Funcs.ibcnt) & " devices at addresses = " & flist
                    txtResults.Text = txtResults.Text + NL + "Multiple devices found! Enter correct device address and press SET button."
                Case 1
                    txtResults.Text = "FindLstn: Found" & Str(GPIB32Funcs.ibcnt) & " device at address = " & flist
                Case 0
                    Beep()
                    txtResults.Text = "FindLstn: No devices found"
                    FoundFlg = 0
                    founddev = 0
                Case Else
                    Beep()
                    txtResults.Text = CStr("FindLstn: Undetermined results - GPIB32Funcs.ibcnt = " = Str(GPIB32Funcs.ibcnt))
                    FoundFlg = 0
                    founddev = 0
            End Select
            Devlist(GPIB32Funcs.ibcnt) = GPIB32Funcs.NOADDR
        End If
        txtAddr.Text = Str(founddev)
        addr = foundaddr                        'set found address to devlist(0)
FLexit:
    End Sub
    Private Sub cmdIFC_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdIFC.Click 'sends Iinterface Clear to all devices
        combCmd.Text = ""
        Call GPIB32Funcs.SendIFC(Bd)            'pulse IFC
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("SendIFC Error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            txtResults.Text = "Interface Clear sent"
        End If
    End Sub

    Private Sub cmdInitialize_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdInitialize.Click
        Dim v As Short              'GPIB Controller initialization
        Dim bud As Short
        Call GPIB32Funcs.SendIFC(Bd)                    'pulse IFC
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("SendIFC error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            bud = 0
            Call GPIB32Funcs.ibask(bud, GPIB32Funcs.IbaPAD, Ctlraddr)
            If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then    'get controller's GPIB address
                Call gpiberr("ibpad error")
                txtError.Text = RetMsg
                txtError.Visible = True
            Else
                v = 1
                Call GPIB32Funcs.ibsre(Bd, v)           'assert REN
                If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
                    Call gpiberr("ibsre Error")
                    txtError.Text = RetMsg
                    txtError.Visible = True
                Else
                    vtmo = GPIB32Funcs.T3s              'set timeout 
                    Call GPIB32Funcs.ibtmo(Bd, vtmo)
                    If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
                        Call gpiberr("ibtmo Error")
                        txtError.Text = RetMsg
                        txtError.Visible = True
                    Else
                        Call cmdFindLstn_Click(cmdFindLstn, New System.EventArgs()) 'find devices
                        If FoundFlg = 1 Then
                            dev = founddev 'get found device number
                            ' addr = founddev
                            Device = founddev
                            'txtAddr.Text = Device
                        End If
                        cmdFindLstn.Enabled = True
                        cmdSpoll.Enabled = True
                        cmdDevClr.Enabled = True
                        cmdTrig.Enabled = True
                        cmdSet.Enabled = True
                        cmdRST.Enabled = True
                        cmdCLS.Enabled = True
                        cmdSend.Enabled = True
                        cmdRead.Enabled = True
                        cmdIFC.Enabled = True
                        cmdFindLstn.Enabled = True
                        cmdSpoll.Enabled = True
                        cmdDevClr.Enabled = True
                        cmdWrtData.Enabled = False
                        cmdCloseFile.Enabled = False
                        cmdOpenFile.Enabled = True
                        cmdStopRecord.Enabled = False
                        cmdStartRecord.Enabled = True
                        ckAuto.CheckState = CheckState.Checked
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub cmdRead_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdRead.Click
        'Dim Instring As String      'reads string from a device
        Instring = SPACE80S         'general read
        Call GPIB32Funcs.Receive(Bd, addr, Instring, GPIB32Funcs.DABend)
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("Receive Error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            txtResults.Text = RTrim(Instring)
            Instring = RTrim(Instring)
        End If
    End Sub

    Private Sub cmdRST_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdRST.Click
        Dim eotmode As Short
        Dim Outstring As String
        Outstring = "*RST"      'resets specified device to power on settings
        txtResults.Text = ""
        combCmd.Text = ""
        eotmode = GPIB32Funcs.NLend
        Call GPIB32Funcs.Send(Bd, addr, Outstring, eotmode)
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("Send error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            txtResults.Text = "*RST sent to device" & Str(Device)
        End If
    End Sub

    Private Sub cmdSend_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSend.Click
        Dim eotmode As Short
        Dim Outstring As String         'sends command string to a specified device
        Outstring = combCmd.Text
        txtResults.Text = ""
        eotmode = GPIB32Funcs.NLend
        Call GPIB32Funcs.Send(Bd, addr, Outstring, eotmode)
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("Send error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            If (ckAuto.CheckState = 1) And (InStr(Outstring, "?") <> 0) Then
                Call cmdRead_Click(cmdRead, New System.EventArgs())
            Else
                txtResults.Text = "Send String => " & Outstring
            End If
        End If
    End Sub

    Private Sub cmdSet_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSet.Click
        Dim ln As Short
        Dim sad As Short
        Dim pad As Short
        Dim L As Short
        Dim Newaddr As Short
        txtError.Visible = False
        Newaddr = Val(txtAddr.Text)
        If Newaddr <> Ctlraddr Then
            FoundFlg = 0
            If (Newaddr >= 100) And (Newaddr <= 3030) Then
                L = Len(txtAddr.Text)                   'get new device number-primary address
                If L = 3 Then
                    pad = Val(VB.Left(txtAddr.Text, 1))
                    sad = Val(Mid(txtAddr.Text, 2, 2)) + 96
                    addr = ((sad) * 256) + pad          'combined NI ppss data address
                ElseIf L = 4 Then
                    pad = Val(VB.Left(txtAddr.Text, 2))
                    sad = Val(Mid(txtAddr.Text, 3, 2)) + 96
                    addr = ((sad) * 256) + pad          'combined NI ppss data address
                Else
                    txtError.Text = "Length of address is out of range, reenter"
                    txtError.Visible = True
                    GoTo Sexit                          'secondary addr error exit
                End If

            ElseIf (Newaddr >= 0) And (Newaddr <= 30) Then
                pad = Val(txtAddr.Text)
                sad = 0
                addr = pad                              'NI pp address value
            Else
                Beep()
                txtResults.Text = "Device Address outside of 0 to 30 or 100 to 3030 range, please reenter"
                GoTo Sexit                              'primary addr error exit
            End If
            Device = Val(txtAddr.Text)                  'process address
            Call GPIB32Funcs.ibln(Bd, pad, sad, ln)
            If ln = 0 Then
                txtResults.Text = "Device not present at address " & Str(Device) & ".  Check device address and retry"
                Beep()
                GoTo Sexit
            End If
            dev = pad
            txtResults.Text = "Device Address => " & Str(Device)
            FoundFlg = 1                            'set device found flag
        Else
            Beep()
            txtResults.Text = "New Device address same as Controller's address,  please reenter"
        End If
Sexit:  combCmd.Text = ""
    End Sub

    Private Sub cmdSpoll_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSpoll.Click
        Dim spresp As Short 'Serial Polls specified device
        combCmd.Text = ""
        Call GPIB32Funcs.ReadStatusByte(Bd, addr, spresp)
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("SPoll Error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            txtResults.Text = "Serial poll response for device" & Str(Device) & " = " & Str(spresp)
        End If
    End Sub

    Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        Dim Rev As String       'program routine to load and initialize the form
        NL = Chr(13) & Chr(10)
        SPACE80S = Space(80)            '80 spaces
        Rev = "Revised 05-02-2007"
        txtRev.Text = Rev
        txtError.Text = ""              'clear label and text box
        txtResults.Text = ""
        Bd = 0                          'define initial values
        bddev = 0
        Ctlraddr = 0
        dev = 4                         'default device ID                            '
        addr = 4
        Device = 4
        txtAddr.Text = CStr(addr)
        txtRev.Text = "Revised " + Revdate
        cmdInitialize.Enabled = True    'show active controls
        cmdExit.Enabled = True
        cmdSet.Enabled = False
        cmdRST.Enabled = False
        cmdCLS.Enabled = False
        cmdSend.Enabled = False
        cmdRead.Enabled = False
        cmdIFC.Enabled = False
        cmdFindLstn.Enabled = False
        cmdSpoll.Enabled = False
        cmdDevClr.Enabled = False
        cmdTrig.Enabled = False
        cmdWrtData.Enabled = False
        cmdCloseFile.Enabled = False
        cmdOpenFile.Enabled = False
        cmdStopRecord.Enabled = False
        cmdStartRecord.Enabled = False
        combCmd.Items.Insert(0, "*esr?")
        combCmd.Items.Insert(1, "*idn?")
        combCmd.Items.Insert(2, "*stb?")
        ckCR.CheckState = System.Windows.Forms.CheckState.Unchecked
        ckLF.CheckState = System.Windows.Forms.CheckState.Checked
        ckAuto.CheckState = System.Windows.Forms.CheckState.Checked
        txtResults.Enabled = True
        txtError.Enabled = False
        RecordFlg = 0
    End Sub

    Private Sub txtAddr_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles txtAddr.TextChanged 'program routine for address box change
        cmdSet.Enabled = True
    End Sub

    Private Sub cmdTrig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdTrig.Click
        combCmd.Text = ""
        Call GPIB32Funcs.Trigger(Bd, addr)     'device trigger
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("DevTrigger Error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            txtResults.Text = "Device Trigger (GET) sent to device" & Str(Device)
        End If
    End Sub

    Public Sub cmdOpenFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdOpenFile.Click
        If InStr(txtFileName.Text, ".txt") = 0 Then
            MsgBox("Missing .txt file type.  Reenter.")
            GoTo Openexit
        End If
        FILE_NAME = "..\" + txtFileName.Text
        If My.Computer.FileSystem.FileExists(FILE_NAME) Then
            MsgBox("File found. Data will be added to an existing file")
            cmdWrtData.Enabled = True
            cmdCloseFile.Enabled = True
            cmdOpenFile.Enabled = False
            FileOpenFlg = 1
            Return
        Else
            MsgBox("File not found. A new file will be created")
            sw = My.Computer.FileSystem.OpenTextFileWriter(FILE_NAME, True)
            cmdWrtData.Enabled = True
            cmdCloseFile.Enabled = True
            cmdOpenFile.Enabled = False
            FileOpenFlg = 1
        End If
Openexit:
    End Sub

    Public Sub cmdWrtData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdWrtData.Click
        sw.WriteLine(Instring)
    End Sub

    Private Sub cmdCloseFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCloseFile.Click
        sw.Close()
        cmdWrtData.Enabled = False
        cmdCloseFile.Enabled = False
        cmdOpenFile.Enabled = True
        FileOpenFlg = 0
    End Sub

    Private Sub combCmd_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles combCmd.KeyPress
        Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
        If KeyAscii = (13) Then
            Call cmdSend_Click(cmdSend, New System.EventArgs())
        End If
        eventArgs.KeyChar = Chr(KeyAscii)
        If KeyAscii = 0 Then
            eventArgs.Handled = True
        End If
    End Sub

    Public Sub cmdStartRecord_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdStartRecord.Click
        If (Val(txtTimeDelay.Text)) < 100 Then
            MsgBox("Time Delay value mising or less than 100 ms.  Reenter.")
            GoTo Startexit
        End If
        Timer1.Interval = (Val(txtTimeDelay.Text))
        Timer1.Enabled = True
        RecordFlg = 1
        cmdStopRecord.Enabled = True
        cmdStartRecord.Enabled = False
        txtRecordCnt.Visible = True
        RecordCnt = 0
        txtRecordCnt.Text = Str$(RecordCnt)
Startexit:
    End Sub

    Private Sub cmdStopRecord_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdStopRecord.Click
        ' Timer1.Interval = Val(txtTimeDelay.Text)
        RecordFlg = 0
        cmdStopRecord.Enabled = False
        cmdStartRecord.Enabled = True
    End Sub

    Public Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        'Dim Instring As New Instring as string
        If RecordFlg = 1 Then
            If ckSendCmd.Checked = True Then
                Call cmdSend_Click(cmdSend, New System.EventArgs())
                If Instring <> "" Then
                    sw.WriteLine(Instring)
                Else
                    MsgBox("Instring = null, No data written")
                End If
            Else
                Call cmdRead_Click(cmdRead, New System.EventArgs())
                If Instring <> "" Then
                    sw.WriteLine(Instring)
                Else
                    MsgBox("Instring = null, No data written")
                End If
            End If
            RecordCnt = RecordCnt + 1
            txtRecordCnt.Text = Str$(RecordCnt)
        End If
    End Sub
End Class
